#!/bin/sh
####### This Program can run in a crontab of UNIX or a schedule of Windows
#**************************************************************************#  
# PROGRAM: CCKeyMsg.sh      
#**************************************************************************#  
# INPUT:  no                                                                   
#***************************************************************************  
# Description:  This sample script, is provided on a AS IS basis.
#               It issues a warning prior to expiration
#               of Concurrent License keys     
#
#***************************************************************************  
# Usage UNIX: Insert this entry into crontab to run it each night at 1am
#             (asuming the script is stored in /usr/local/bin)       
#
#    0 1 * * * /usr/local/bin/CCKeyMsg.sh > /tmp/CCKeyMsg.cron  2>&1  &                  
#                                                                           
##***************************************************************************  
# Usage Windows: A UNIX toolkit have to be installed 
#                ( MKS Toolkit, Microsoft SFU, GNU - Freeware) 
#           Use: Start/Programs/Accessories/System Tools/Scheduled Tasks
#                and define to run it daily 
#**************************************************************************#  
# (C) COPYRIGHT International Business Machines Corp. 2005                 #  
#**************************************************************************#  
#                written: Nov.27.2005       M. Maier                             
#**************************************************************************#                                                                       

# Run Unix or Windows ?
# OS can be UNIX or XP
OS="UNIX"
#OS="XP"


#-------------------------------------------------------------------------
if [ $OS = "XP" ] 
then
 # For Windows

 # Temporary formated file 
 OUT=c:/temp/expire_list.txt
 OUT1=c:/temp/expire_list1.txt
 OUT_CSV=c:/temp/expire_list.csv
 
 # Warning File
  WARNING_FILE=C:/temp/LUM_WARNING_FOR_KEY_EXPIRATION

else
 # For UNIX
 
 export PATH=/usr/opt/ifor/bin:$PATH
 # For AIX change LANG to work on all NLS Locals
   export LANG=C
 #
 # Temporary formated file
 OUT=/tmp/expire_list.txt
 OUT1=/tmp/expire_list1.txt
 OUT_CSV=/tmp/expire_list.csv

 # Warning File
 WARNING_FILE=/tmp/LUM_WARNING_FOR_KEY_EXPIRATION

fi

# Warning Flag
WARN=0
SWARN=0

# Date Today
DAT=`date` 
CYER=`date +"%Y"`
CMON=`date +"%m"`
CDAY=`date +"%d"` 

# Format i4blt -ll command to Temporary File

 i4blt -ll | awk  ' { if ($1=="Product" && $2=="Name:") printf"%-40s :",$0 ; 
             else  { if ($1=="Start") print $9,$10,$11 } }'| cut -d":" -f2,3 |cut -c15-70 > $OUT

# create OUT1 with date in it 
date > $OUT1 
echo " " >> $OUT1


# Read Information from Input File
while read LINE 
do


PROD=`echo $LINE | cut -d":" -f1`
MON=`echo $LINE | cut -d":" -f2 | cut -d" " -f1`


case $MON in 
   Jan) DMON=01 ;;
   Feb) DMON=02 ;;
   Mar) DMON=03 ;;
   Apr) DMON=04 ;;
   May) DMON=05 ;;
   Jun) DMON=06 ;;
   Jul) DMON=07 ;;
   Aug) DMON=08 ;;
   Sep) DMON=09 ;;
   Oct) DMON=10 ;;
   Nov) DMON=11 ;;
   Dec) DMON=12 ;;
esac

DAY=`echo $LINE | cut -d":" -f2 | cut -d" " -f2` 
YER=`echo $LINE | cut -d":" -f2 | cut -d" " -f3` 


# Check for expiration ---------------------------
if [ $CYER -gt $YER ]
   then 
   COMMENT="-Expired -" 
   WARN=1

 elif [ $CYER -lt  $YER ]
   then
   COMMENT="Valid $YER"
   WARN=0
   if [ $CMON = 12 -a $DMON = 1 ]
    then
    COMMENT="Next Month"
    WARN=1
   fi

 else
   let Delta=$DMON-$CMON  
   if [ $Delta -gt 1  ]
   then
       COMMENT="Valid- $MON"
       WARN=0
   elif [ $Delta -lt 1 -a $Delta != 0 ]
   then  
       COMMENT="-Expired -"
       WARN=1
   elif [ $Delta = 1 ]
   then
      COMMENT="Next Month"
      WARN=1 
   else
      COMMENT="This Month"
      WARN=1    
   fi
fi

if [ $WARN = "1" ] 
  then SWARN=1 
fi
 
echo $WARN $COMMENT "  " $MON $DAY $YER $PROD 
echo $WARN $COMMENT "  " $MON $DAY $YER $PROD  >> $OUT1
echo $WARN";"$COMMENT";"$MON";"$DAY";"$YER";"$PROD   >> $OUT_CSV

done < $OUT

### Create the Warning if one or more Licences are expired
if [ $SWARN = 1 ] 
  then
  #  One or more Licences are below one Month and needs attention
  #
  #  send an eMail in here with mailto command or fillup an error log 
  #
  #
  # By default an Error is written to tmp Dir
  
     echo   > $WARNING_FILE
     echo  >> $WARNING_FILE
     echo " The expiration  date for one or more Licences are below one Month"   >> $WARNING_FILE
     echo " and need attention !! "                                              >> $WARNING_FILE

     echo  >> $WARNING_FILE
     cat $OUT1 >> $WARNING_FILE
  ### Do any action you want below this if statement: ----------------   ###### INSERT Here 
  # ....  your statements .......

  #
  #
  #--------------------------------------------------------------------------------------
fi 


#  clean TMP
 rm $OUT $OUT1

# FOR DEBUG


exit 0


 






